# -*- coding: utf-8 -*-
"""
Created on Thu Dec 10 16:09:34 2015
@author: Peter Meisrimel
"""
from pylab import close
from main_run import run_files
import sys
close('all')

"""
How to:
Enter input files as a list to be run (run as a group)
or 
Enter input files as arguments when starting from console (run in sequence)
"""
if len(sys.argv) == 1:
    print('performing input from main.py')
    ############# VERIFICATION RUN MODES AND PROBLEMS
    run_files('input_files/run_mode_verification/adjoints/problem_{}{}.txt', [0, 12], [''])
    run_files('input_files/run_mode_verification/run_mode_{}{}.txt', [-1,0,1,2,10], [''])
    run_files('input_files/run_mode_verification/RK/run_mode_0.txt')
    run_files('input_files/run_mode_verification/{}/run_mode_0{}.txt',
              ['toy', 'ver', 'ver_time', 'heat_src_adv', 'FSI_2D'], [''])
    ############# 0  TOY PROBLEM
    """ RUN MODE   0, basic testing to show convergence """
    #run_files('input_files/0_basic_testing/toy/k_{}_t_2/func_{}.txt', [-1,-100], [1,2,21,22,31,32,10])
    #run_files('input_files/0_basic_testing/toy/k_{}_t_2/func_{}.txt', [-1, -100], [1,2,10,21,32]) # Test problem verfication
    """ RUN_MODE   1, tolerance comparison of various controllers and DWR """
    #run_files('input_files/1_tolerance_DWR/toy/k_{}/func_{}.txt', [-1], [1, 2]) # Test problem performance comparison 
    #run_files('input_files/1_tolerance_DWR/toy/k_{}/func_{}.txt', [-100], [1]) # Test problem performance comparison
    
    ############# 12 HEAT SOURCE ADVECTION PROBLEM
    """ RUN_MODE  -1, reference solution """
    #run_files('input_files/-1_reference/heat_src_advection/dx_32_t_6/tol_{}.txt', [10**(-i) for i in range(5,9)])
    #run_files('input_files/-1_reference/heat_src_advection_reverse/dx_32_t_3/tol_{}.txt', [10**(-i) for i in range(5,12)])
    """ RUN MODE   0, basic testing to show convergence """
    #run_files('input_files/0_basic_testing/heat_src_advection/func_{}.txt', [1]) # Conv diff problem verification
    """ RUN_MODE   1, tolerance comparison of various controllers and DWR """
    #run_files('input_files/1_tolerance_DWR/heat_src_advection/func_{}.txt', [1]) # Conv diff problem performance with DWR
    #run_files('input_files/1_tolerance_DWR/heat_src_advection_reverse/func_{}.txt', [1]) # Conv diff problem performance with DWR
    """ RUN_MODE   2, tolerance comparison of defined input files """
    #run_files('input_files/2_tolerances/heat_src_advection/forward/func_1/est_{}.txt', [0,1]) # Conv diff problem performance (no DWR) + timesteps
    #run_files('input_files/2_tolerances/heat_src_advection/backward/func_1/est_{}.txt', [0,1]) # Conv diff problem performance (no DWR) + timesteps
    
    ############# 21  2 D COUPLED HEAT EQUATIONS
    """ RUN_MODE  -1, reference solution """
    #run_files('input_files/-1_reference/FSI_2D_new_u0/u0_2/ref_tol_{}.txt', [10**(-i) for i in range(5, 8)])
    #run_files('input_files/-1_reference/FSI_2D_new_u0/u0_5/ref_tol_{}.txt', [10**(-i) for i in range(5, 8)])
    """ RUN_MODE   2, tolerance comparison of defined input files """
    #run_files('input_files/2_tolerances/FSI_2D/u0_{}/est_{}.txt', [2], [0,1]) # coupled heat problem performance + timesteps
    #run_files('input_files/2_tolerances/FSI_2D/u0_{}/est_{}.txt', [5], [0,1]) # coupled heat problem performance + timesteps
    
else:
    print('performing input from terminal')
    for i in range(1, len(sys.argv)):
        run_files(sys.argv[i])