# -*- coding: utf-8 -*-
"""
Created on Wed Apr 18 14:40:25 2018
@author: Peter Meisrimel
"""
from __future__ import division
import scipy as sp
import pylab as pl
import numpy as np
pl.close('all')

def u0(x,y):
    return abs((200*np.sin(np.pi*y**2)*np.sin((np.pi/2)*(x**2))))
def u1(x,y):
    return 200*np.sin(np.pi*y**2)*(x-1)**4
def u2(x,y):
    if x >= 1:
        return 200
    return 0
def u3(x, y):
    if x >= 1:
        return (400*(np.sin(3*np.pi*y)**2)*(np.sin(3*np.pi*x)**2))
    return 0
def u4(x, y):
    if x >= 1:
        return (800*(np.sin(np.pi*y)**4)*(np.sin(np.pi*x)**4))
    return 0

def get_u0(n, u0_func):
    x1 = np.linspace(0,1, n+2)
    xplot = np.linspace(0,2, 2*n+3)
        
    U_0 = np.zeros((2*n+1, n))
    for i in range(2*n+1):
        for j in range(n):
            U_0[i,j] = u0_func(xplot[i+1],x1[j+1])
            
    pl.subplots(figsize = (10, 5))
    pl.pcolormesh(U_0.T)
    pl.axis([0, 2*n+1, 0, n])
    pl.colorbar()
    pl.plot([n+1, n+1], [0, n], 'k-', lw = 5)

n = 200
get_u0(n, u0)
get_u0(n, u1)
get_u0(n, u2)
get_u0(n, u3)
get_u0(n, u4)